Title: WP_REST_Search_Controller::register_routes
Published: December 6, 2018
Last modified: May 20, 2026

---

# WP_REST_Search_Controller::register_routes()

## In this article

 * [Description](https://developer.wordpress.org/reference/classes/wp_rest_search_controller/register_routes/?output_format=md#description)
    - [See also](https://developer.wordpress.org/reference/classes/wp_rest_search_controller/register_routes/?output_format=md#see-also)
 * [Source](https://developer.wordpress.org/reference/classes/wp_rest_search_controller/register_routes/?output_format=md#source)
 * [Related](https://developer.wordpress.org/reference/classes/wp_rest_search_controller/register_routes/?output_format=md#related)
 * [Changelog](https://developer.wordpress.org/reference/classes/wp_rest_search_controller/register_routes/?output_format=md#changelog)

[ Back to top](https://developer.wordpress.org/reference/classes/wp_rest_search_controller/register_routes/?output_format=md#wp--skip-link--target)

Registers the routes for the search controller.

## 󠀁[Description](https://developer.wordpress.org/reference/classes/wp_rest_search_controller/register_routes/?output_format=md#description)󠁿

### 󠀁[See also](https://developer.wordpress.org/reference/classes/wp_rest_search_controller/register_routes/?output_format=md#see-also)󠁿

 * [register_rest_route()](https://developer.wordpress.org/reference/functions/register_rest_route/)

## 󠀁[Source](https://developer.wordpress.org/reference/classes/wp_rest_search_controller/register_routes/?output_format=md#source)󠁿

    ```php
    public function register_routes() {
    	register_rest_route(
    		$this->namespace,
    		'/' . $this->rest_base,
    		array(
    			array(
    				'methods'             => WP_REST_Server::READABLE,
    				'callback'            => array( $this, 'get_items' ),
    				'permission_callback' => array( $this, 'get_items_permission_check' ),
    				'args'                => $this->get_collection_params(),
    			),
    			'schema' => array( $this, 'get_public_item_schema' ),
    		)
    	);
    }
    ```

[View all references](https://developer.wordpress.org/reference/files/wp-includes/rest-api/endpoints/class-wp-rest-search-controller.php/)
[View on Trac](https://core.trac.wordpress.org/browser/tags/7.0/src/wp-includes/rest-api/endpoints/class-wp-rest-search-controller.php#L91)
[View on GitHub](https://github.com/WordPress/wordpress-develop/blob/7.0/src/wp-includes/rest-api/endpoints/class-wp-rest-search-controller.php#L91-L105)

## 󠀁[Related](https://developer.wordpress.org/reference/classes/wp_rest_search_controller/register_routes/?output_format=md#related)󠁿

| Uses | Description | 
| [WP_REST_Search_Controller::get_collection_params()](https://developer.wordpress.org/reference/classes/wp_rest_search_controller/get_collection_params/)`wp-includes/rest-api/endpoints/class-wp-rest-search-controller.php` |

Retrieves the query params for the search results collection.

  | 
| [register_rest_route()](https://developer.wordpress.org/reference/functions/register_rest_route/)`wp-includes/rest-api.php` |

Registers a REST API route.

  |

## 󠀁[Changelog](https://developer.wordpress.org/reference/classes/wp_rest_search_controller/register_routes/?output_format=md#changelog)󠁿

| Version | Description | 
| [5.0.0](https://developer.wordpress.org/reference/since/5.0.0/) | Introduced. |

## User Contributed Notes

You must [log in](https://login.wordpress.org/?redirect_to=https%3A%2F%2Fdeveloper.wordpress.org%2Freference%2Fclasses%2Fwp_rest_search_controller%2Fregister_routes%2F)
before being able to contribute a note or feedback.